﻿@section scripts{
    <script src="~/ADMIN/JS/persian-date.js"></script>
    <script src="~/ADMIN/JS/persian-datepicker-0.4.5.js"></script>
}

@section Styles{
    <link href="~/ADMIN/Content/Styles/persian-datepicker-0.4.5.css" rel="stylesheet" />
<style>
    .mybadge{
        background-color: #3f51b5;padding: 2px 10px;border-radius: 10px;color: #FFF;
    }
</style>
}

<div class="wrapper-grid">
    <div class="k-rtl">
    @(Html.Kendo().Grid<LawMingo.Models.ViewModel.Blog.PostViewModel>()
      .Name("grid")
      .Events(dv => dv.Edit("Edit").DataBound("PostsBound"))
      .Columns(columns =>
      {
          columns.Bound(c => c.Image).Width(100).Sortable(false).Filterable(false).ClientTemplate("#=_DisplayImage(Image, 'Posts')#"); ;
          //columns.Bound(c => c.Disable).ClientTemplate("<input type='checkbox' #= Disable ? checked='checked' :'' # />");
          columns.Bound(c => c.Title);
          columns.Bound(c => c.commentCount).ClientTemplate(
                        "# if (commentCount > 0) { #" +
                    "<span class='mybadge'>#=commentCount#</span>" +
                "# }#"
              ).Title(" ").Width(100).Filterable(false);
          columns.Bound(c => c.PublishTime).ClientTemplate("#=persianTime(kendo.toString(PublishTime,'yyyy-MM-ddTHH:mm:ss'))#");
          columns.Bound(c => c.Color).Width(100).Sortable(false).Filterable(false).ClientTemplate("#=_DisplayColor(Color)#");
          columns.Bound(c => c.FontColor).Width(100).Sortable(false).Filterable(false).ClientTemplate("#=_DisplayColor(FontColor)#");
          columns.Bound(c => c.Url).ClientTemplate("<a role='button' class='k-button k-button-icontext' href='#=Url#'>نمایش</a>");

          columns.Command(command => { command.Edit().Text("ویرایش"); command.Destroy().Text("حذف"); }).Width(300);
      })
      .ToolBar(toolbar =>
      {
          toolbar.Create().Text("پست جدید");
      })
      .ColumnMenu()
        .Editable(editable => editable.Mode(GridEditMode.PopUp).Window(q => q.Width(800)))
        .Pageable(pageable =>
            pageable
            .Refresh(true)
            .Input(true)
            .PageSizes(true)
            .ButtonCount(10).Messages(m => m.ItemsPerPage("نمایش در هر صفحه"))
        )
      .Navigatable()
      .Selectable(selectable =>
      {
          selectable.Mode(GridSelectionMode.Single);
          selectable.Type(GridSelectionType.Row);
      })
      .Sortable(sortable =>
      {
          sortable.SortMode(GridSortMode.SingleColumn);
      })
      .Filterable()
        .Scrollable(s => s.Height("auto").Enabled(false))
      .DataSource(dataSource => dataSource
          .Ajax()
          .Model(model => model.Id(p => p.PostID))
          .Read(read => read.Action("posts_Read", "Posts"))
          .Create(create => create.Action("posts_Create", "Posts"))
          .Update(update => update.Action("posts_Update", "Posts"))
          .Destroy(destroy => destroy.Action("posts_Destroy", "Posts"))
      )
    .ClientDetailTemplateId("Details-Template")

        )

    </div>
</div>

<script id="Details-Template" type="text/kendo-tmpl">
@(Html.Kendo().TabStrip()
            .Name("tabStrip_#=PostID#")
            .SelectedIndex(0)
            .TabPosition(TabStripTabPosition.Top)
            .Animation(animation => animation.Open(open => open.Fade(FadeDirection.In)))
            .Items(items =>
            {
            #region مطالب مرتبط

            items.Add().Text("مطالب مرتبط").Content(
                @<text>
                    @(Html.Kendo().Grid<LawMingo.Models.DomainModel.RelatedPost>()
                        .Name("SubjectChildren_#=PostID#")
                        .Events(ev => ev.Edit("function(e){RelatedEdit(e ,'#=PostID#')}"))
                        .Columns(columns =>
                        {
                            columns.Bound(c => c.Title);
                            columns.Command(command => {command.Destroy().Text("حذف"); }).Width(300);
                        })
                        .ToolBar(toolbar =>
                        {
                            toolbar.Create().Text("مورد جدید");
                        })
                        .ColumnMenu()
                        .Editable(editable => editable.Mode(GridEditMode.PopUp).Window(q => q.Width(800)))
                        .Pageable(pageable =>
                            pageable
                            .Refresh(true)
                            .Input(true)
                            .PageSizes(true)
                            .ButtonCount(10).Messages(m => m.ItemsPerPage("نمایش در هر صفحه"))
                        )
                        .Navigatable()
                        .Selectable(selectable =>
                        {
                            selectable.Mode(GridSelectionMode.Single);
                            selectable.Type(GridSelectionType.Row);
                        })
                        .Sortable(sortable =>
                        {
                            sortable.SortMode(GridSortMode.SingleColumn);
                        })
                        .Filterable()
                        .Scrollable(s => s.Height("auto").Enabled(false))
                        .DataSource(dataSource => dataSource
                            .Ajax()
                            .Model(model =>
                                {
                                    model.Id(p => p.RelatedPostID);
                                    model.Field(p => p.PostID);
                                }
                            )
                            .Read(read => read.Action("RelatedPosts_Read", "RelatedPosts", new { _PostID = "#=PostID#"}))
                            .Create(create => create.Action("RelatedPosts_Create", "RelatedPosts", new { _PostID = "#=PostID#" }))
                            .Update(update => update.Action("RelatedPosts_Update", "RelatedPosts"))
                            .Destroy(destroy => destroy.Action("RelatedPosts_Destroy", "RelatedPosts"))
                        )
                        .ToClientTemplate()
                    )
                </text>
            );
            #endregion

            #region کامنت ها
            items.Add().Text("کامنت ها").Content(
                @<text>
                    @(Html.Kendo().Grid<LawMingo.Models.DomainModel.Comment>()
                        .Name("Coments_#=PostID#")
                        .Columns(columns =>
                        {
                            columns.Bound(c => c.Author);
           columns.Bound(c => c.AuthorEmail);

                            columns.Bound(c => c.Time);
                            columns.Bound(c => c.Content);
                            columns.Command(command => {command.Destroy().Text("حذف");command.Custom("activeComment").Click("activeComment").Text("انتشار");
                            command.Custom("readComment").Click("readComment").Text("خوانده شد");}).Width(300);
                        })
                        .ToolBar(toolbar =>
                        {
                            toolbar.Create().Text("کامنت جدید");
                        })
                        .Events(ev => ev.DataBound("CommentsBound").Edit("CommentEdit"))
                      .ColumnMenu()
                        .Editable(editable => editable.Mode(GridEditMode.PopUp).Window(q => q.Width(800)))
                        .Pageable(pageable =>
                            pageable
                            .Refresh(true)
                            .Input(true)
                            .PageSizes(true)
                            .ButtonCount(10).Messages(m => m.ItemsPerPage("نمایش در هر صفحه"))
                        )
                      .Navigatable()
                      .Selectable(selectable =>
                      {
                          selectable.Mode(GridSelectionMode.Single);
                          selectable.Type(GridSelectionType.Row);
                      })
                      .Sortable(sortable =>
                      {
                          sortable.SortMode(GridSortMode.SingleColumn);
                      })
                      .Filterable()
                        .Scrollable(s => s.Height("auto").Enabled(false))
                      .DataSource(dataSource => dataSource
                          .Ajax()
                          .Model(model => model.Id(p => p.CommentID))
                          .Read(read => read.Action("Comments_Read", "Comments" , new { _PostID = "#=PostID#" }))
                          .Create(create => create.Action("Comments_Create", "Comments" , new { _PostID = "#=PostID#" }))
                          .Update(update => update.Action("Comments_Update", "Comments"))
                          .Destroy(destroy => destroy.Action("Comments_Destroy", "Comments"))
                      )
                      .ClientDetailTemplateId("CommentAnswers-Template")
                      .ToClientTemplate()
                    )
                </text>
            );
            #endregion

            #region رشته پست
            items.Add().Text("رشته پست").Content(
                @<text>
                رشته پست
                </text>
            );
            #endregion


            }).ToClientTemplate())
</script>

<script id="active-template" type="text/x-kendo-template">
    <span>عدم انتشار</span>
</script>​

<script>

    function activeComment(e) {
        e.preventDefault();
        var dataItem = this.dataItem($(e.currentTarget).closest("tr"));
        var ret = $.ajax({
            type: "POST",
            url: "/blogpanel/comments/active",
            data: { id : dataItem.CommentID },
            dataType: "json",
            complete: function (response) {
                var msg = response ? "منتشر شد" : "عدم انتشار";
                var grid = $(e.delegateTarget).data("kendoGrid");
                grid.refresh();
                alert(msg);
            }
        });
    }

    function readComment(e) {
        e.preventDefault();
        var dataItem = this.dataItem($(e.currentTarget).closest("tr"));
        var ret = $.ajax({
            type: "POST",
            url: "/blogpanel/comments/read",
            data: { id : dataItem.CommentID },
            dataType: "json",
            complete: function (response) {
                //var msg = response ? "خوانده شد" : "عدم انتشار";
                //var grid = $(e.delegateTarget).data("kendoGrid");
                //grid.refresh();
                alert('خوانده شد');
            }
        });
    }

    function test(val) {
        //alert(val);
        return({
            PostID: val
        });
    }

    function PostsBound(e){
        var data = e.sender.dataSource.data();
        $.each(data, function (i, row) {
            if (row.Disable) {
                $('tr[data-uid="' + row.uid + '"] ').css("background-color", "#ffebeb");
            }
        })
    }
    function CommentsBound(e){
        var data = e.sender.dataSource.data();
        console.log("CommentsBound");
        $.each(data, function (i, row) {
            console.log(row.IsActive)
            if (!row.IsActive) {
                $('tr[data-uid="' + row.uid + '"] ').css("background-color", "#ffebeb");
            }
            if (!row.IsRead) {
                $('tr[data-uid="' + row.uid + '"] ').css("font-weight" , "bold");
            }
        })
    }

    function RelatedEdit(e , PostID){
            e.model.set("PostID" , PostID);
            $(e.container["0"].firstChild.children[2]).hide();
            $(e.container["0"].firstChild.children[3]).hide();
        }

        function RelatedEdit2(val) {
            alert(val);
        }

        function Edit(e) {

            $(e.container["0"].firstChild.children[0]).hide();
            $(e.container["0"].firstChild.children[1]).hide();
            $(e.container["0"].firstChild.children[2]).hide();
            $(e.container["0"].firstChild.children[3]).hide();

        var kendoWindow = e.container.data("kendoWindow");
        if (e.model.isNew()) {
            kendoWindow.setOptions({
                title: "پست جدید"
            });
        }
        else {
            kendoWindow.setOptions({
                title: "ویرایش پست"
            });
        }

        $(".PublishTime").pDatepicker({
            format: "YYYY/MM/DD HH:mm:ss",
            timePicker: {
                enabled: true
            },
            onSelect: function () {
                var ww = moment($("." + e.container.prevObject["0"].lastElementChild.attributes["0"].ownerDocument.activeElement.className).val(), 'jYYYY/jM/jD HH:mm:ss')
                    .format('YYYY-M-D HH:mm:ss') // 2013-8-25 16:40:00
                $("#" + e.container.prevObject["0"].lastElementChild.attributes["0"].ownerDocument.activeElement.className).val(ww).trigger('change');
                //moment.loadPersian()
            }
        });
    }

        function CommentEdit(e) {
            $(e.container["0"].firstChild.children[2]).hide();
            $(e.container["0"].firstChild.children[3]).hide();
            $(e.container["0"].firstChild.children[4]).hide();
            $(e.container["0"].firstChild.children[5]).hide();
            $(e.container["0"].firstChild.children[6]).hide();
            $(e.container["0"].firstChild.children[7]).hide();
        }
</script>

<script id="CommentAnswers-Template" type="text/kendo-tmpl">
    @(Html.Kendo().Grid<LawMingo.Models.DomainModel.Comment>()
       .Name("Answers_#=CommentID#")
       .Columns(columns =>
       {
           columns.Bound(c => c.Author);
           columns.Bound(c => c.AuthorEmail);
           columns.Bound(c => c.Time);
           columns.Bound(c => c.Content);
           columns.Command(command => { command.Destroy().Text("حذف");}).Width(300);
       })
       .ToolBar(toolbar =>
       {
           toolbar.Create().Text("پاسخ جدید");
       }
       )
       .Events(ev => ev.DataBound("CommentsBound").Edit("CommentEdit"))
       .ColumnMenu()
       .Editable(editable => editable.Mode(GridEditMode.PopUp).Window(q => q.Width(800)))
       .Pageable(pageable =>
           pageable
           .Refresh(true)
           .Input(true)
           .PageSizes(true)
           .ButtonCount(10).Messages(m => m.ItemsPerPage("نمایش در هر صفحه"))
       )
       .Navigatable()
       .Selectable(selectable =>
       {
           selectable.Mode(GridSelectionMode.Single);
           selectable.Type(GridSelectionType.Row);
       })
       .Sortable(sortable =>
       {
           sortable.SortMode(GridSortMode.SingleColumn);
       })
       .Filterable()
       .Scrollable(s => s.Height("auto").Enabled(false))
       .DataSource(dataSource => dataSource
           .Ajax()
           .Model(model => model.Id(p => p.CommentID))
           .Read(read => read.Action("Comments_Read", "Comments", new { _CommentID = "#=CommentID#"  ,  _PostID = "#=PostID#"}))
           .Create(create => create.Action("Comments_Create", "Comments", new { _CommentID = "#=CommentID#" ,  _PostID = "#=PostID#" }))
           .Update(update => update.Action("Comments_Update", "Comments"))
           .Destroy(destroy => destroy.Action("Comments_Destroy", "Comments"))
       )
       .ToClientTemplate()
    )
</script>